-- Upgrade script to 5.2 from 5.3.

-- add on delete cascade in MSD related tables
-- In mysql we don't check if the constraint already exists before dropping because
-- it requires either special connection string (allow user variables) or new store proc for each drop

ALTER TABLE METADATA_TARGET DROP FOREIGN KEY FK_METADATA_TARGET_TO_ITEM
;

ALTER TABLE METADATA_TARGET   ADD  CONSTRAINT FK_METADATA_TARGET_TO_ITEM FOREIGN KEY(MDT_ID)
REFERENCES ITEM (ITEM_ID)
ON DELETE CASCADE
;

ALTER TABLE TARGET_OBJECT DROP FOREIGN KEY FK_TARGET_OBJECT_To_CCOMMON
;

ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TARGET_OBJECT_To_CCOMMON FOREIGN KEY(TARGET_OBJ_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

ALTER TABLE TARGET_OBJECT DROP FOREIGN KEY FK_TARGET_OBJECT_To_MDT
;

ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TARGET_OBJECT_To_MDT FOREIGN KEY(MDT_ID)
REFERENCES METADATA_TARGET (MDT_ID)
ON DELETE CASCADE
;

ALTER TABLE METADATA_TARGET DROP FOREIGN KEY FK_METADATA_TARGET_TO_MSD
;

ALTER TABLE METADATA_TARGET   ADD  CONSTRAINT FK_METADATA_TARGET_TO_MSD FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
ON DELETE CASCADE
;

ALTER TABLE METADATA_STRUCTURE_DEFINITION DROP FOREIGN KEY FK_MSD_TO_ARTEFACT
;

ALTER TABLE METADATA_STRUCTURE_DEFINITION   ADD  CONSTRAINT FK_MSD_TO_ARTEFACT FOREIGN KEY(MSD_ID)
REFERENCES ARTEFACT (ART_ID)
ON DELETE CASCADE
;

ALTER TABLE REPORT_STRUCTURE DROP FOREIGN KEY FK_REPORT_STRUCTURE_To_ITEM
;


ALTER TABLE REPORT_STRUCTURE   ADD  CONSTRAINT FK_REPORT_STRUCTURE_To_ITEM FOREIGN KEY(RS_ID)
REFERENCES ITEM (ITEM_ID)
ON DELETE CASCADE
;

ALTER TABLE REPORT_STRUCTURE DROP FOREIGN KEY FK_REPORT_STRUCTURE_To_MSD
;

ALTER TABLE REPORT_STRUCTURE   ADD  CONSTRAINT FK_REPORT_STRUCTURE_To_MSD FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
ON DELETE CASCADE
;

-- sync name with Oracle 
ALTER TABLE REPORT_STRUCTURE_META_TARGET DROP FOREIGN KEY FK_REPORT_STRUCTURE_META_TARGET_METADATA_TARGET
;

ALTER TABLE REPORT_STRUCTURE_META_TARGET   ADD  CONSTRAINT FK_REP_STRUCT_META_TAR_MD_TAR FOREIGN KEY(MDT_ID)
REFERENCES METADATA_TARGET (MDT_ID)
ON DELETE CASCADE
;

-- sync name with Oracle 
ALTER TABLE REPORT_STRUCTURE_META_TARGET DROP FOREIGN KEY FK_REPORT_STRUCTURE_META_TARGET_REPORT_STRUCTURE
;

-- not adding an on delete cascade because of SQL Server
ALTER TABLE REPORT_STRUCTURE_META_TARGET   ADD  CONSTRAINT FK_REP_STRU_META_TAR_REP_STRU FOREIGN KEY(RS_ID)
REFERENCES REPORT_STRUCTURE (RS_ID)
;

-- sync name with Oracle 
ALTER TABLE METADATA_ATTRIBUTE DROP FOREIGN KEY FK_METADATA_ATTRIBUTE_COMPONENT_COMMON
;
ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_COMP_COMMON FOREIGN KEY(MTD_ATTR_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;

-- sync name with Oracle 
ALTER TABLE METADATA_ATTRIBUTE DROP FOREIGN KEY FK_METADATA_ATTRIBUTE_METADATA_ATTRIBUTE
;
ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_MD_ATTR FOREIGN KEY(PARENT)
REFERENCES METADATA_ATTRIBUTE (MTD_ATTR_ID)
;

-- add field for notifications
ALTER TABLE DATAFLOW ADD COLUMN DATA_LAST_UPDATE datetime NULL
;

-- always last
update DB_VERSION SET VERSION = '5.3'
;

